Package com.google.protobuf

## Interface Message.Builder

All Superinterfaces:
  `java.lang.Cloneable`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`

All Known Implementing Classes:
  `AbstractMessage.Builder`, `DescriptorProtos.DescriptorProto.Builder`, `DescriptorProtos.DescriptorProto.ExtensionRange.Builder`, `DescriptorProtos.EnumDescriptorProto.Builder`, `DescriptorProtos.EnumOptions.Builder`, `DescriptorProtos.EnumValueDescriptorProto.Builder`, `DescriptorProtos.EnumValueOptions.Builder`, `DescriptorProtos.FieldDescriptorProto.Builder`, `DescriptorProtos.FieldOptions.Builder`, `DescriptorProtos.FileDescriptorProto.Builder`, `DescriptorProtos.FileDescriptorSet.Builder`, `DescriptorProtos.FileOptions.Builder`, `DescriptorProtos.MessageOptions.Builder`, `DescriptorProtos.MethodDescriptorProto.Builder`, `DescriptorProtos.MethodOptions.Builder`, `DescriptorProtos.OneofDescriptorProto.Builder`, `DescriptorProtos.ServiceDescriptorProto.Builder`, `DescriptorProtos.ServiceOptions.Builder`, `DescriptorProtos.SourceCodeInfo.Builder`, `DescriptorProtos.SourceCodeInfo.Location.Builder`, `DescriptorProtos.UninterpretedOption.Builder`, `DescriptorProtos.UninterpretedOption.NamePart.Builder`, `DynamicMessage.Builder`, `GeneratedMessage.Builder`, `GeneratedMessage.ExtendableBuilder`

Enclosing interface:
  Message

    public static interface Message.Builder
    extends MessageLite.Builder, MessageOrBuilder

Abstract interface implemented by Protocol Message builders.

### Method Summary

All Methods Instance Methods Abstract Methods
`Message.Builder` `addRepeatedField​(Descriptors.FieldDescriptor field, java.lang.Object value)` Like `setRepeatedField`, but appends the value as a new element.
`Message` `build()` Constructs the message based on the state of the Builder.
`Message` `buildPartial()` Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields.
`Message.Builder` `clear()` Resets all fields to their default values.
`Message.Builder` `clearField​(Descriptors.FieldDescriptor field)` Clears the field.
`Message.Builder` `clearOneof​(Descriptors.OneofDescriptor oneof)` Clears the oneof.
`Message.Builder` `clone()` Clones the Builder.
`Descriptors.Descriptor` `getDescriptorForType()` Get the message's type's descriptor.
`Message.Builder` `getFieldBuilder​(Descriptors.FieldDescriptor field)` Get a nested builder instance for the given field.
`boolean` `mergeDelimitedFrom​(java.io.InputStream input)` Like `MessageLite.Builder.mergeFrom(InputStream)`, but does not read until EOF.
`boolean` `mergeDelimitedFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeDelimitedFrom(InputStream)` but supporting extensions.
`Message.Builder` `mergeFrom​(byte[] data)` Parse `data` as a message of this type and merge it with the message being built.
`Message.Builder` `mergeFrom​(byte[] data, int off, int len)` Parse `data` as a message of this type and merge it with the message being built.
`Message.Builder` `mergeFrom​(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`Message.Builder` `mergeFrom​(byte[] data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`Message.Builder` `mergeFrom​(ByteString data)` Parse `data` as a message of this type and merge it with the message being built.
`Message.Builder` `mergeFrom​(ByteString data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`Message.Builder` `mergeFrom​(CodedInputStream input)` Parses a message of this type from the input and merges it with this message.
`Message.Builder` `mergeFrom​(CodedInputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
`Message.Builder` `mergeFrom​(Message other)` Merge `other` into the message being built.
`Message.Builder` `mergeFrom​(java.io.InputStream input)` Parse a message of this type from `input` and merge it with the message being built.
`Message.Builder` `mergeFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Parse a message of this type from `input` and merge it with the message being built.
`Message.Builder` `mergeUnknownFields​(UnknownFieldSet unknownFields)` Merge some unknown fields into the `UnknownFieldSet` for this message.
`Message.Builder` `newBuilderForField​(Descriptors.FieldDescriptor field)` Create a Builder for messages of the appropriate type for the given field.
`Message.Builder` `setField​(Descriptors.FieldDescriptor field, java.lang.Object value)` Sets a field to the given value.
`Message.Builder` `setRepeatedField​(Descriptors.FieldDescriptor field, int index, java.lang.Object value)` Sets an element of a repeated field to the given value.
`Message.Builder` `setUnknownFields​(UnknownFieldSet unknownFields)` Set the `UnknownFieldSet` for this message.

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`isInitialized`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDefaultInstanceForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

### Method Detail

#### clear

    Message.Builder clear()

Description copied from interface: `MessageLite.Builder`
Resets all fields to their default values.

Specified by:
  `clear` in interface `MessageLite.Builder`

#### mergeFrom

    Message.Builder mergeFrom​(Message other)

Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getDescriptorForType() == other.getDescriptorForType()`). Merging occurs as follows. For each field:
* For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
* For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
* For repeated fields, the elements in `other` are concatenated with the elements in this message. This is equivalent to the `Message::MergeFrom` method in C++.

#### build

    Message build()

Description copied from interface: `MessageLite.Builder`
Constructs the message based on the state of the Builder. Subsequent changes to the Builder will not affect the returned message.

Specified by:
  `build` in interface `MessageLite.Builder`

#### buildPartial

    Message buildPartial()

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields. Instead, a partial message is returned. Subsequent changes to the Builder will not affect the returned message.

Specified by:
  `buildPartial` in interface `MessageLite.Builder`

#### clone

    Message.Builder clone()

Description copied from interface: `MessageLite.Builder`
Clones the Builder.

Specified by:
  `clone` in interface `MessageLite.Builder`
See Also:
  `Object.clone()`

#### mergeFrom

    Message.Builder mergeFrom​(CodedInputStream input)
                       throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Parses a message of this type from the input and merges it with this message.

Warning: This does not verify that all required fields are present in the input message. If you call `MessageLite.Builder.build()` without setting all required fields, it will throw an `UninitializedMessageException`, which is a `RuntimeException` and thus might not be caught. There are a few good ways to deal with this:

- Call `MessageLiteOrBuilder.isInitialized()` to verify that all required fields are set before building.
- Use `buildPartial()` to build, which ignores missing required fields.

Note: The caller should call `CodedInputStream.checkLastTagWas(int)` after calling this to verify that the last tag seen was the appropriate end-group tag, or zero for EOF.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Throws:
  `java.io.IOException`

#### mergeFrom

    Message.Builder mergeFrom​(CodedInputStream input,
                              ExtensionRegistryLite extensionRegistry)
                       throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Throws:
  `java.io.IOException`

#### getDescriptorForType

    Descriptors.Descriptor getDescriptorForType()

Get the message's type's descriptor. See `MessageOrBuilder.getDescriptorForType()`.

Specified by:
  `getDescriptorForType` in interface `MessageOrBuilder`

#### newBuilderForField

    Message.Builder newBuilderForField​(Descriptors.FieldDescriptor field)

Create a Builder for messages of the appropriate type for the given field. Messages built with this can then be passed to setField(), setRepeatedField(), or addRepeatedField().

#### getFieldBuilder

    Message.Builder getFieldBuilder​(Descriptors.FieldDescriptor field)

Get a nested builder instance for the given field.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations(the generated message builders), however, can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder will be returned. Otherwise, a new field builder will be created and returned. The original message field (if exist) will be merged into the field builder, which will then be nested into its parent builder.

NOTE: implementations that do not support nested builders will throw `UnsupportedException`.

#### setField

    Message.Builder setField​(Descriptors.FieldDescriptor field,
                             java.lang.Object value)

Sets a field to the given value. The value must be of the correct type for this field, i.e. the same type that `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` would return.

#### clearField

    Message.Builder clearField​(Descriptors.FieldDescriptor field)

Clears the field. This is exactly equivalent to calling the generated "clear" accessor method corresponding to the field.

#### clearOneof

    Message.Builder clearOneof​(Descriptors.OneofDescriptor oneof)

Clears the oneof. This is exactly equivalent to calling the generated "clear" accessor method corresponding to the oneof.

#### setRepeatedField

    Message.Builder setRepeatedField​(Descriptors.FieldDescriptor field,
                                     int index,
                                     java.lang.Object value)

Sets an element of a repeated field to the given value. The value must be of the correct type for this field, i.e. the same type that `MessageOrBuilder.getRepeatedField(Descriptors.FieldDescriptor,int)` would return.

Throws:
  `java.lang.IllegalArgumentException` - The field is not a repeated field, or `field.getContainingType() != getDescriptorForType()`.

#### addRepeatedField

    Message.Builder addRepeatedField​(Descriptors.FieldDescriptor field,
                                     java.lang.Object value)

Like `setRepeatedField`, but appends the value as a new element.

Throws:
  `java.lang.IllegalArgumentException` - The field is not a repeated field, or `field.getContainingType() != getDescriptorForType()`.

#### setUnknownFields

    Message.Builder setUnknownFields​(UnknownFieldSet unknownFields)

Set the `UnknownFieldSet` for this message.

#### mergeUnknownFields

    Message.Builder mergeUnknownFields​(UnknownFieldSet unknownFields)

Merge some unknown fields into the `UnknownFieldSet` for this message.

#### mergeFrom

    Message.Builder mergeFrom​(ByteString data)
                       throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    Message.Builder mergeFrom​(ByteString data,
                              ExtensionRegistryLite extensionRegistry)
                       throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    Message.Builder mergeFrom​(byte[] data)
                       throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    Message.Builder mergeFrom​(byte[] data,
                              int off,
                              int len)
                       throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    Message.Builder mergeFrom​(byte[] data,
                              ExtensionRegistryLite extensionRegistry)
                       throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    Message.Builder mergeFrom​(byte[] data,
                              int off,
                              int len,
                              ExtensionRegistryLite extensionRegistry)
                       throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    Message.Builder mergeFrom​(java.io.InputStream input)
                       throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`. Note that this method always reads the entire input (unless it throws an exception). If you want it to stop earlier, you will need to wrap your input in some wrapper stream that limits reading. Or, use `MessageLite.writeDelimitedTo(OutputStream)` to write your message and `MessageLite.Builder.mergeDelimitedFrom(InputStream)` to read it.

Despite usually reading the entire input, this does not close the stream.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `java.io.IOException`

#### mergeFrom

    Message.Builder mergeFrom​(java.io.InputStream input,
                              ExtensionRegistryLite extensionRegistry)
                       throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Returns:
  this
Throws:
  `java.io.IOException`

#### mergeDelimitedFrom

    boolean mergeDelimitedFrom​(java.io.InputStream input)
                        throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(InputStream)`, but does not read until EOF. Instead, the size of the message (encoded as a varint) is read first, then the message data. Use `MessageLite.writeDelimitedTo(OutputStream)` to write messages in this format.

Specified by:
  `mergeDelimitedFrom` in interface `MessageLite.Builder`
Returns:
  True if successful, or false if the stream is at EOF when the method starts. Any other error (including reaching EOF during parsing) will cause an exception to be thrown.
Throws:
  `java.io.IOException`

#### mergeDelimitedFrom

    boolean mergeDelimitedFrom​(java.io.InputStream input,
                               ExtensionRegistryLite extensionRegistry)
                        throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeDelimitedFrom(InputStream)` but supporting extensions.

Specified by:
  `mergeDelimitedFrom` in interface `MessageLite.Builder`
Throws:
  `java.io.IOException`